/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.basiswerte;

import de.bernhardjung.dsaprogramm.basis.Held;

class Astralenergie extends Basiswert {

    Astralenergie(
            final String dieId,
            final int derIndex,
            final Formel dieFormel,
            final int derSteigerungsfaktor,
            final MaxZukauf derZukauf ) {

        super( dieId, derIndex, dieFormel, derSteigerungsfaktor, derZukauf );
    }

    @Override
    public int getBasisstufe( final Held held ) {

        if ( held.istZauberer() ) {

            return super.getBasisstufe( held );

        } else {

            return 0;
        }
    }
}
