/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.daten.factorys.bausteine;

import static de.bernhardjung.dsaprogramm.daten.xml.HeldenbausteinXmlTags.TAG_EMPFOHLENE_VOR_NACH;

import java.util.ArrayList;
import java.util.List;

import net.n3.nanoxml.IXMLElement;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteil;

public class FactoryEmpfohleneVorNachteileIn {

    /**
     * @param wurzelElement der XML-Datei.
     * @return eine Liste von Vor-/Nachteilen.
     */
    public final List< VorNachteil > erzeugen( final IXMLElement wurzelElement ) {

        final List< VorNachteil > vorNachteileListe =
            new ArrayList< VorNachteil >();

        final IXMLElement vorNachteile =
            wurzelElement.getFirstChildNamed( TAG_EMPFOHLENE_VOR_NACH );

        if ( null != vorNachteile ) {

            for ( final IXMLElement vorNachteil : vorNachteile.getChildren() ){

                final String id = vorNachteil.getContent();

                vorNachteileListe.add( VorNachteil.getVorNachteil( id ) );
            }
        }

        return vorNachteileListe;
    }
}
