package de.bernhardjung.dsaprogramm.gui;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.layout.FormLayout;
import de.bernhardjung.dsaprogramm.basis.varianten.Variante;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.Sonderfertigkeit;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.SonderfertigkeitWert;
import de.bernhardjung.dsaprogramm.util.Uebersetzer;
import de.bernhardjung.dsaprogramm.util.Util;

import javax.swing.*;


public class PanelBenutzerdefinierteSonderfertigkeit extends JPanel {

    /** Label fuer den Spinner mit den GP-Kosten. */
    private static final String APKOSTEN = "PanelBenutzerdefinierteSonderfertigkeit.ApKosten";
    /** Label fuer das Textfeld in das man den Namen des Vor-/Nachteils eingibt. */
    private static final String NAME = "PanelBenutzerdefinierteSonderfertigkeit.Name";

    /** Spinner fuer die GP-Kosten. */
    private final JSpinner apKosten;

    /** Hier gibt man den Namen des Vor-/Nachteils ein. */
    private final JTextField name;

    /** Kann die Texte im Panel beim Sprachwechsel neu uebersetzen. */
    private final Uebersetzer uebersetzer;

    /** Erzeugt alle Elemente (Spinner,Buttons,...) der Benutzeroberflaeche. */
    public PanelBenutzerdefinierteSonderfertigkeit() {

        uebersetzer = new Uebersetzer();

        apKosten = Util.erzeugeSpinner( 100, 0, 950, 50 );

        name = new JTextField();

        aufbauenBenutzeroberflaeche();
    }

    /** Erzeugt das Layout und baut die Benutzeroberflaeche auf. */
    private void aufbauenBenutzeroberflaeche() {

        FormLayout layout = new FormLayout( "P, 4dlu, P, P:grow" );
        DefaultFormBuilder builder = new DefaultFormBuilder( layout, this );
        builder.setDefaultDialogBorder();

        builder.append( uebersetzer.erzeugeLabel( NAME ) );
        builder.append( name, 2 );

        builder.append( uebersetzer.erzeugeLabel( APKOSTEN ) );
        builder.append( apKosten );
    }

    /** Liefert die eingegebenen Daten. */
    private Variante getVariante() {

        String nameString = name.getText().trim();
        Variante variante = new Variante( nameString );
        variante.setApKosten( ( Integer ) apKosten.getValue() );
        return variante;
    }

    /**
     * Erzeugt einen Wert mit den eingegebenen Daten.
     * Der Wert kann dem helden hinzugefuegt werden.
     */
    public SonderfertigkeitWert getWert() {

        Sonderfertigkeit sonderfertigkeit = Sonderfertigkeit.BENUTZERDEFINIERT;

        Variante variante = getVariante();

        return new SonderfertigkeitWert( sonderfertigkeit, variante, false );
    }

    /** Ubersetzt das Panel bei einem Sprachwechsel. */
    public void neuUebersetzen() {
        uebersetzer.neuUebersetzen();
    }
}
