/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.gui.action;

import de.bernhardjung.dsaprogramm.gui.Hauptpanel;
import de.bernhardjung.dsaprogramm.gui.meta.DialogDatenquelle;

public class ActionDatenquelle extends CharGenAction {

    /** Der Dialog der mit der Aktion aufgerufen wird. */
    private DialogDatenquelle dialog;

    public ActionDatenquelle( final Hauptpanel dasHauptpanel ) {
        super( dasHauptpanel,
                "ActionDatenquelle.Name",
                "ActionDatenquelle.Tasten",
                "ActionDatenquelle.Mnemonic" );
    }

    protected void actionPerformed() {

        getDialogDatenquelle().setVisible( ! getDialogDatenquelle().isVisible() );
    }

    public DialogDatenquelle getDialogDatenquelle() {

        if ( null == dialog ) {

            dialog = new DialogDatenquelle( hauptpanel.getHauptfenster() );
            
            dialog.setLocationRelativeTo( hauptpanel );
        }

        return dialog;
    }
    
    @Override
    public void neuUebersetzen() {
        
        super.neuUebersetzen();
        
        if ( null != dialog ) {
            
            dialog.neuUebersetzen();
        }
    }
}
