/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.sonderfertigkeiten.kosten;

import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.SonderfertigkeitWert;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteil;

class KostenNandusgefaelligesWissen extends KostenFest {

    /** Die AP-Kosten von Nandusgefaelliges Wissen. */
    private static final int AP_KOSTEN = 200;
    
    KostenNandusgefaelligesWissen()  {
        super( AP_KOSTEN );
    }
    
    public int getApKosten(
            final Held held, 
            final SonderfertigkeitWert wert ) {
        
        if ( held.hat( VorNachteil.AKADEMISCHE_AUSBILDUNG_GELEHRTER ) ) {
            
            return 0;
        }
        
        return super.getApKosten( held, wert );
        
    }

}
